/*
*  GetHostBy utility
*  
*  source/netlib.c
*  snapshot 20040216
*  
*  (c) 6.1.2003 Jaroslav Beran berk@volny.cz http://www.volny.cz/berk
*  License GNU/GPL2  
*/


#include "netlib.h"


int init_netlib(void)
{
#ifndef __linux__
        WSADATA wsaData;
        WORD version;


        version = MAKEWORD( 2, 0 );

        if (WSAStartup( version, &wsaData ))
                return -1;

        if ( LOBYTE( wsaData.wVersion ) != 2 || HIBYTE( wsaData.wVersion ) != 0 ){
                WSACleanup();
                return -1;
        }
#endif
        return 0;
}


void close_netlib(void)
{
#ifndef __linux__
        WSACleanup();
#endif
        return;
}


int tcp_readline(MYSOCK fd, char *ptr, int maxlen)
{
        int n, rc;
        char c;


        ptr[0] = '\0';
        for (n = 1; n < maxlen; n++) {
                if ((rc = recv(fd, &c, 1, 0)) == 1) {
                        *ptr++ = c;
                        if (c == '\n')
                        break;
                } else {
                        if (rc == 0) {
                                if (n == 1)
                                        return 0;       /* EOF, no data read */
                                else
                                        break;          /* EOF, some data was read */
                        } else {
                                return -1;              /* error */
                        }
                }
        }

        *ptr = '\0';
        return n;
}


#ifdef __linux__
int closesocket(MYSOCK fd)
{
        return close(fd);
}
#endif
